//+------------------------------------------------------------------+
//|                                                   doshur Bot.mq4 |
//|                                                           doshur |
//|                                                   www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "doshur"
#property link      "www.doshur.com"

//---- input parameters

extern double StopLoss = 40;
extern double TrailingStop = 20;

//----

int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

//----

int start()
  {
//---- General

   double Spread = Ask - Bid;
   double Current_Price = iClose(NULL,1,1);
   double PP = (iHigh(NULL,0,2) + iLow(NULL,0,2) + iClose(NULL,0,2)) / 3;

//---- MAs

   double Now_MA_Signal, Prev_MA_Signal;
   double Now_MA_MainClose, Prev_MA_MainClose;

   Now_MA_Signal = iMA(NULL,0,5,0,MODE_LWMA,PRICE_CLOSE,1);
   Prev_MA_Signal = iMA(NULL,0,5,0,MODE_LWMA,PRICE_CLOSE,2);

   Now_MA_MainClose = iMA(NULL,0,8,0,MODE_SMA,PRICE_CLOSE,1);
   Prev_MA_MainClose = iMA(NULL,0,8,0,MODE_SMA,PRICE_CLOSE,2);

//---- MA Trend

   double MA_Trend = iMA(NULL,0,13,1,MODE_SMMA,PRICE_CLOSE,0);
   double MA_Trend_Long = iMA(NULL,0,50,0,MODE_SMA,PRICE_CLOSE,0);

//---- MFI RSI

   double RSI = iRSI(NULL,0,13,PRICE_CLOSE,1);
   double MFI = iMFI(NULL,0,13,1);

//---- POI MACD 1 min entry

   double POI_Main = iCustom(NULL,1,"Perfect Over Indicator",13,13,13,0,1);
   double POI_Signal = iCustom(NULL,1,"Perfect Over Indicator",13,13,13,1,1);

   double MACD_Main = iMACD(NULL,1,12,26,8,PRICE_CLOSE,MODE_MAIN,1);
   double MACD_Signal = iMACD(NULL,1,12,26,8,PRICE_CLOSE,MODE_SIGNAL,1);

//---- Buy

   static bool BuyAction = false;

   if(BuyAction == false)
   if(Check_OpenTrades(1) < 1)
   if(Current_Price > PP)
   if(MFI < 40 && RSI > 50)
   if(Now_MA_Signal > MA_Trend)
   if(MA_Trend > MA_Trend_Long)
   if(MACD_Main > MACD_Signal)
   if(Now_MA_MainClose < Now_MA_Signal && Prev_MA_MainClose >= Prev_MA_Signal)
   {
      BuyAction = true;
   }

   if(BuyAction == true)
   if(POI_Main > POI_Signal)
   {
      OrderSend(Symbol(),OP_BUY,Check_Lots(),Ask,3,Ask - StopLoss * Point,0,"doshur",0,0,Blue);
      BuyAction = false;
   }

   if(Now_MA_MainClose > Now_MA_Signal)
   {
      BuyAction = false;
   }

//---- Sell

   static bool SellAction = false;

   if(SellAction == false)
   if(Check_OpenTrades(2) < 1)
   if(Current_Price < PP)
   if(MFI > 60 && RSI < 50)
   if(Now_MA_Signal < MA_Trend)
   if(MA_Trend < MA_Trend_Long)
   if(MACD_Main < MACD_Signal)
   if(Now_MA_MainClose > Now_MA_Signal && Prev_MA_MainClose <= Prev_MA_Signal)
   {
      SellAction = true;
   }

   if(SellAction == true)
   if(POI_Main < POI_Signal)
   {
      OrderSend(Symbol(),OP_SELL,Check_Lots(),Bid,3,Bid + StopLoss * Point,0,"doshur",0,0,Red);
      SellAction = false;
   }

   if(Now_MA_MainClose < Now_MA_Signal)
   {
      SellAction = false;
   }

//---- Close Buy

   int cntB = 0;

   if(Now_MA_MainClose > Now_MA_Signal && Prev_MA_MainClose <= Prev_MA_Signal)
   {
      for(cntB = 0; cntB < OrdersTotal(); cntB++)
      {
         OrderSelect(cntB, SELECT_BY_POS, MODE_TRADES);
         if(OrderType() == OP_BUY)
         if((Bid - OrderOpenPrice()) > Spread)
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Black);
         }
         /*else
         {
            if(MA_Trend > Now_MA_Signal)
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Black);
         }*/
      }
   }

//---- Close Sell

   int cntS = 0;

   if(Now_MA_MainClose < Now_MA_Signal && Prev_MA_MainClose >= Prev_MA_Signal)
   {
      for(cntS = 0; cntS < OrdersTotal(); cntS++)
      {
         OrderSelect(cntS, SELECT_BY_POS, MODE_TRADES);
         if(OrderType() == OP_SELL)
         if((OrderOpenPrice() - Ask) > Spread)
         {
            OrderClose(OrderTicket(),OrderLots(),Ask,3,Black);
         }
         /*else
         {
            if(MA_Trend < Now_MA_Signal)
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Black);
         }*/
      }
   }

//---- Trailing Stop

   for(int i = 0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) continue;
      if(OrderType() == OP_BUY)
      {
         if(Bid - OrderOpenPrice() > Point * TrailingStop)
         {
            if(OrderStopLoss() < Bid - Point * TrailingStop)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * TrailingStop,OrderTakeProfit(),0,Green);
               return(0);
            }
         }
      }

      if(OrderType() == OP_SELL)
      {
         if((OrderOpenPrice() - Ask) > (Point * TrailingStop))
         {
            if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0))
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * TrailingStop,OrderTakeProfit(),0,Green);
               return(0);
            }
         }
      }
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+

//---- Check Open Trades

int Check_OpenTrades(int bs)
  {
   int buys = 0, sells = 0;

   for(int c_OT = 0; c_OT < OrdersTotal(); c_OT++)
   {
      OrderSelect(c_OT, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() == OP_BUY)
         buys++;
      if(OrderType() == OP_SELL)
         sells++;
   }

   if(bs == 1)
      return(buys);

   if(bs == 2)
      return(sells);
  }

//---- Optimize Lots

double Check_Lots()
  {
   double rLots;

   rLots = NormalizeDouble(AccountBalance() / 100 * 0.4 / 40,1); // account balance / margin * risk / 40?
   
   if(rLots < 0.1)
      rLots = 0.1;

   return(rLots);
  }